> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dodopayments.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Customer Wallet Ledger Entry

> Add or deduct monetary funds in a customer's wallet. Use entry_type 'credit' to add funds or 'debit' to deduct funds. Wallet balances are real money (USD, INR) that can be applied to subscription invoices.



## OpenAPI

````yaml post /customers/{customer_id}/wallets/ledger-entries
openapi: 3.1.0
info:
  title: public
  description: ''
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  version: 1.102.0
servers:
  - url: https://test.dodopayments.com/
    description: Test Mode Server Host
  - url: https://live.dodopayments.com/
    description: Live Mode Server Host
security: []
tags:
  - name: Products
  - name: Payments
  - name: Subscriptions
  - name: Addons
  - name: Customers
  - name: Refunds
  - name: Disputes
  - name: Events
  - name: License Keys
  - name: Entitlements
  - name: Licenses
  - name: Discounts
  - name: Meters
  - name: Credit Entitlements
  - name: Credit Entitlement Balances
  - name: Outgoing Webhooks
  - name: Checkout
  - name: Webhook Events
paths:
  /customers/{customer_id}/wallets/ledger-entries:
    post:
      tags:
        - Customers
      operationId: create_customer_ledger_entry
      parameters:
        - name: customer_id
          in: path
          description: Customer ID
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CustomerLedgerEntryRequest'
        required: true
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomerWalletResponse'
        '400':
          description: Insufficient balance for debit
        '422':
          description: Invalid Request Object or Parameters
        '500':
          description: Something went wrong :(
      security:
        - API_KEY: []
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import DodoPayments from 'dodopayments';


            const client = new DodoPayments({
              bearerToken: process.env['DODO_PAYMENTS_API_KEY'], // This is the default and can be omitted
            });


            const customerWallet = await
            client.customers.wallets.ledgerEntries.create('customer_id', {
              amount: 0,
              currency: 'AED',
              entry_type: 'credit',
            });


            console.log(customerWallet.customer_id);
        - lang: Python
          source: |-
            import os
            from dodopayments import DodoPayments

            client = DodoPayments(
                bearer_token=os.environ.get("DODO_PAYMENTS_API_KEY"),  # This is the default and can be omitted
            )
            customer_wallet = client.customers.wallets.ledger_entries.create(
                customer_id="customer_id",
                amount=0,
                currency="AED",
                entry_type="credit",
            )
            print(customer_wallet.customer_id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/dodopayments/dodopayments-go\"\n\t\"github.com/dodopayments/dodopayments-go/option\"\n)\n\nfunc main() {\n\tclient := dodopayments.NewClient(\n\t\toption.WithBearerToken(\"My Bearer Token\"),\n\t)\n\tcustomerWallet, err := client.Customers.Wallets.LedgerEntries.New(\n\t\tcontext.TODO(),\n\t\t\"customer_id\",\n\t\tdodopayments.CustomerWalletLedgerEntryNewParams{\n\t\t\tAmount:    dodopayments.F(int64(0)),\n\t\t\tCurrency:  dodopayments.F(dodopayments.CurrencyAed),\n\t\t\tEntryType: dodopayments.F(dodopayments.CustomerWalletLedgerEntryNewParamsEntryTypeCredit),\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", customerWallet.CustomerID)\n}\n"
        - lang: Java
          source: >-
            package com.dodopayments.api.example;


            import com.dodopayments.api.client.DodoPaymentsClient;

            import com.dodopayments.api.client.okhttp.DodoPaymentsOkHttpClient;

            import com.dodopayments.api.models.customers.wallets.CustomerWallet;

            import
            com.dodopayments.api.models.customers.wallets.ledgerentries.LedgerEntryCreateParams;

            import com.dodopayments.api.models.misc.Currency;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    DodoPaymentsClient client = DodoPaymentsOkHttpClient.fromEnv();

                    LedgerEntryCreateParams params = LedgerEntryCreateParams.builder()
                        .customerId("customer_id")
                        .amount(0L)
                        .currency(Currency.AED)
                        .entryType(LedgerEntryCreateParams.EntryType.CREDIT)
                        .build();
                    CustomerWallet customerWallet = client.customers().wallets().ledgerEntries().create(params);
                }
            }
        - lang: Kotlin
          source: >-
            package com.dodopayments.api.example


            import com.dodopayments.api.client.DodoPaymentsClient

            import com.dodopayments.api.client.okhttp.DodoPaymentsOkHttpClient

            import com.dodopayments.api.models.customers.wallets.CustomerWallet

            import
            com.dodopayments.api.models.customers.wallets.ledgerentries.LedgerEntryCreateParams

            import com.dodopayments.api.models.misc.Currency


            fun main() {
                val client: DodoPaymentsClient = DodoPaymentsOkHttpClient.fromEnv()

                val params: LedgerEntryCreateParams = LedgerEntryCreateParams.builder()
                    .customerId("customer_id")
                    .amount(0L)
                    .currency(Currency.AED)
                    .entryType(LedgerEntryCreateParams.EntryType.CREDIT)
                    .build()
                val customerWallet: CustomerWallet = client.customers().wallets().ledgerEntries().create(params)
            }
        - lang: Ruby
          source: >-
            require "dodopayments"


            dodo_payments = Dodopayments::Client.new(
              bearer_token: "My Bearer Token",
              environment: "test_mode" # defaults to "live_mode"
            )


            customer_wallet =
            dodo_payments.customers.wallets.ledger_entries.create(
              "customer_id",
              amount: 0,
              currency: :AED,
              entry_type: :credit
            )


            puts(customer_wallet)
        - lang: PHP
          source: |-
            <?php

            require_once dirname(__DIR__) . '/vendor/autoload.php';

            use Dodopayments\Client;
            use Dodopayments\Core\Exceptions\APIException;
            use Dodopayments\Misc\Currency;

            $client = new Client(
              bearerToken: getenv('DODO_PAYMENTS_API_KEY') ?: 'My Bearer Token',
              environment: 'test_mode',
            );

            try {
              $customerWallet = $client->customers->wallets->ledgerEntries->create(
                'customer_id',
                amount: 0,
                currency: Currency::AED,
                entryType: 'credit',
                idempotencyKey: 'idempotency_key',
                reason: 'reason',
              );

              var_dump($customerWallet);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: C#
          source: >-
            using System;

            using DodoPayments.Client;

            using DodoPayments.Client.Models.Customers.Wallets.LedgerEntries;

            using DodoPayments.Client.Models.Misc;


            DodoPaymentsClient client = new();


            LedgerEntryCreateParams parameters = new()

            {
                CustomerID = "customer_id",
                Amount = 0,
                Currency = Currency.Aed,
                EntryType = EntryType.Credit,
            };


            var customerWallet = await
            client.Customers.Wallets.LedgerEntries.Create(parameters);


            Console.WriteLine(customerWallet);
components:
  schemas:
    CustomerLedgerEntryRequest:
      type: object
      required:
        - entry_type
        - currency
        - amount
      properties:
        amount:
          type: integer
          format: int64
        currency:
          $ref: '#/components/schemas/Currency'
          description: Currency of the wallet to adjust
        entry_type:
          $ref: '#/components/schemas/CustomerLedgerEntryType'
          description: Type of ledger entry - credit or debit
        idempotency_key:
          type:
            - string
            - 'null'
          description: Optional idempotency key to prevent duplicate entries
        reason:
          type:
            - string
            - 'null'
    CustomerWalletResponse:
      type: object
      required:
        - customer_id
        - currency
        - balance
        - created_at
        - updated_at
      properties:
        balance:
          type: integer
          format: int64
        created_at:
          type: string
          format: date-time
        currency:
          $ref: '#/components/schemas/Currency'
        customer_id:
          type: string
        updated_at:
          type: string
          format: date-time
    Currency:
      type: string
      enum:
        - AED
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BWP
        - BYN
        - BZD
        - CAD
        - CHF
        - CLP
        - CNY
        - COP
        - CRC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STN
        - SVC
        - SZL
        - THB
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VES
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
    CustomerLedgerEntryType:
      type: string
      enum:
        - credit
        - debit
  securitySchemes:
    API_KEY:
      type: http
      scheme: bearer

````